// PG_FormEdit.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_FormEdit.h"
#include "PG_FormWin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE( PG_FormEdit, CEdit )

/////////////////////////////////////////////////////////////////////////////
// PG_FormEdit

PG_FormEdit::PG_FormEdit()
{
	m_bShiftDown = FALSE;
}

PG_FormEdit::~PG_FormEdit()
{
}

BEGIN_MESSAGE_MAP(PG_FormEdit, CEdit)
	//{{AFX_MSG_MAP(PG_FormEdit)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		ON_WM_CREATE()
		ON_WM_KEYUP()
		ON_WM_KEYDOWN()
		ON_WM_CHAR()
		ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PG_FormEdit message handlers

/////////////////////////////////////////////////////////////////////////////
// Create the form edit field
int PG_FormEdit::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if ( CEdit::OnCreate( lpCreateStruct ) == -1 )
		return -1;
	
  lpCreateStruct->dwExStyle |= WS_EX_CLIENTEDGE;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Keyboard event handlers take of care accelerate the 'return' key
void PG_FormEdit::OnKeyUp( UINT nChar, UINT nRepCnt, UINT nFlags )
{
  BYTE b = LOBYTE( nChar );
	if ( b == VK_RETURN )
    {
      ( ( PG_FormWin * ) GetParent() )->DoSearch();
    }
  else if ( b == VK_TAB )
    {
      PG_FormWin *pForm = ( PG_FormWin * ) GetParent();
      CWnd *pWndNext = pForm->GetNextDlgTabItem( ( CWnd * ) this, m_bShiftDown );
      if ( pWndNext != NULL )
        {
          if ( pWndNext->IsKindOf( RUNTIME_CLASS( PG_FormEdit ) ) )
            ( ( PG_FormEdit * ) pWndNext )->m_bShiftDown = m_bShiftDown;

          m_bShiftDown = FALSE;
          pWndNext->SetFocus();
        }
    }
  else if ( b == VK_SHIFT )
    {
      m_bShiftDown = FALSE;
    }
  else
	  CEdit::OnKeyUp( nChar, nRepCnt, nFlags );
}

/////////////////////////////////////////////////////////////////////////////
// Keyboard event handlers take of care accelerate the 'return' key
void PG_FormEdit::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags ) 
{
  BYTE b = LOBYTE( nChar );
	if ( b == VK_RETURN || b == VK_TAB )
    {
      ;
    }
  else if ( b == VK_SHIFT )
    {
      m_bShiftDown = TRUE;
    }
  else
	  CEdit::OnKeyDown( nChar, nRepCnt, nFlags );
}

/////////////////////////////////////////////////////////////////////////////
// Keyboard event handlers take of care accelerate the 'return' key
void PG_FormEdit::OnChar( UINT nChar, UINT nRepCnt, UINT nFlags ) 
{
  BYTE b = LOBYTE( nChar );
	if ( b == 0x0d || b == 0x09 )
    {
      ;
    }
  else	
	  CEdit::OnChar( nChar, nRepCnt, nFlags );
}

/////////////////////////////////////////////////////////////////////////////
// PG_FormEdit::OnSetFocus
// Set the selection when the edit control gets the keyboard focus.
void PG_FormEdit::OnSetFocus( CWnd *pOldWnd ) 
{
	SetSel( 0, -1 );
  CEdit::OnSetFocus( pOldWnd );
}

