#if !defined(AFX_PG_FORMWIN_H__DDC0BC63_259F_11D3_89E9_E5FC92093B0F__INCLUDED_)
#define AFX_PG_FORMWIN_H__DDC0BC63_259F_11D3_89E9_E5FC92093B0F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PG_FormWin.h : header file
//

#include "PG_FormEdit.h"
#include "PG_Button.h"
#include "ptrlist.h"
#include "qutil.h"
#include "PG_FormHandler.h"
#include "QFormSearch.h"

/////////////////////////////////////////////////////////////////////////////
// PG_FormField aggregates a label and edit control

class PG_FormField
{
public:
	PG_FormField
		( CString &name,
			class PG_FormWin *parent,
			class QFormInput *pInput,
			UINT label_id,
			UINT edit_id,
			UINT left,
			UINT right,
			UINT top );

	~PG_FormField();

public:
	PG_FormWin *Form() { return m_pFormWin; } ;

public:
	CString FieldName();
	void GetValue( CString &str );
	void GetRect( CRect &rect );
	void SetFieldValue();
	void Clear();

public:
	void SizeControls( CWnd *parent, UINT left, UINT right, UINT top );

private:
	PG_FormWin *m_pFormWin;
	QFormInput *m_pInput;
	CString field_name;
	CRect bound_rect;
	CStatic label;
	PG_FormEdit edit;
	UINT m_nLabelID;
	UINT m_nEditID;
};

template PtrList<PG_FormField>;

/////////////////////////////////////////////////////////////////////////////
// PG_FormWin window

class PG_FormWin : public CWnd
{
// Construction
public:
	PG_FormWin( QForm *pForm );

// Attributes
public:
  CFont *m_pNormalFont;
	CFont *m_pBoldFont;

// Operations
public:
	BOOL Create( CWnd *parent, CRect &rect, UINT id );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PG_FormWin)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~PG_FormWin();

public:
	void DoSearch();

private:
	BOOL CreateFields
		( QStringList &field_name_list, UINT &left, UINT &right, UINT &top, QFormInput *ffi );

	void CreateFonts();

private:
	//
	// The form definition
	QForm *m_pForm;

	// Input field placeholders
	QFormInput *target_ffi;
	PtrList<QFormInput> context_ffi_list;

	//
	// List of field input windows
	PtrList<PG_FormField> field_list;
	UINT id_acc;

	//
	// Static form help strings
	CStatic m_staticTitle;
	CStatic m_staticHelp;

	//
	// Form buttons
	PG_Button m_submitButton;
	PG_Button m_clearButton;
	
	//
	// Request and request handler
	QFormSearch *m_pRequest;
	PG_FormHandler m_requestHandler;

	// Generated message map functions
protected:
	//{{AFX_MSG(PG_FormWin)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
  afx_msg void OnSubmit();
  afx_msg void OnClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

template PtrList<PG_FormWin>;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PG_FORMWIN_H__DDC0BC63_259F_11D3_89E9_E5FC92093B0F__INCLUDED_)
