// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__279C66FB_14FB_11D3_9024_0020AFF7CE08__INCLUDED_)
#define AFX_MAINFRM_H__279C66FB_14FB_11D3_9024_0020AFF7CE08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"
#include "PG_LHSTabCtrl.h"
#include "PG_RHSTabCtrl.h"
#include "PG_WaitDialog.h"
#include "PG_StatusBar.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:

// Operations
public:
	void CreateTabPages();
	void WaitMode( BOOL bOn);
	void SetMessageText(LPCTSTR pStr);
	void FlashMessageText();
	PG_WaitDialog *WaitDialog() { return &m_waitDialog; } ;
	void SetOpCounts( int nInvoked, int nFailed );
	void AddSearchMenuItems();
	void AddSearchMenuItem(CString &rName, int nTabID);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
	PG_WaitDialog m_waitDialog;
	BOOL m_bWait;
	int m_nWaitFrameIdx;
	BOOL m_bSrchMenuEmpty;

protected:  // control bar embedded members
	PG_StatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CReBar      m_wndReBar;
	CDialogBar  m_wndDlgBar;
	CDialogBar	m_wndAnimBar;
	CChildView  m_wndView;

private:
	void SetWaitAnimFrame( int nFrameID );

public:
	void SetStatusText( LPCTSTR pStr );
	PG_LHSTabCtrl *m_pLhsTabCtrl;
	PG_RHSTabCtrl *m_pRhsTabCtrl;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg LRESULT OnSocketClose(WPARAM wParam, LPARAM lParam);
	afx_msg void OnWaitAbort();
	afx_msg void OnUpdateFileAbort(CCmdUI* pCmdUI);
	afx_msg void OnSrchMenuItem(UINT nID);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__279C66FB_14FB_11D3_9024_0020AFF7CE08__INCLUDED_)
