// QError.h: interface for the QError class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QERROR_H__31AFB0A6_A6FD_11D2_89E9_980EE8619202__INCLUDED_)
#define AFX_QERROR_H__31AFB0A6_A6FD_11D2_89E9_980EE8619202__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "qutil.h"

extern "C" {
#ifdef _NS_LDAP
#include "lber.h"
#include "ldap.h"
#else
#include "winldap.h"
#endif
}

typedef unsigned long QErrCode;

#define QERR_OK			0
#define QERR_MASK		0x0700

#define QERR_ATTRIBUTE		(QERR_MASK | 0x0001)
#define QERR_NAME		(QERR_MASK | 0x0002)
#define QERR_SERVICE		(QERR_MASK | 0x0003)
#define QERR_DSAREFERRAL	(QERR_MASK | 0x0004)
#define QERR_ABANDONED		(QERR_MASK | 0x0005)
#define QERR_SECURITY		(QERR_MASK | 0x0006)
#define QERR_ABANDONFAILED	(QERR_MASK | 0x0007)
#define QERR_UPDATE		(QERR_MASK | 0x0008)
#define QERR_INTERNAL_LIMIT	(QERR_MASK | 0x0020)
#define QERR_INTERNAL		(QERR_MASK | 0x0021)
#define QERR_INVALID_ARGUMENT	(QERR_MASK | 0x0022)
#define QERR_INSUFFICIENT_DATA	(QERR_MASK | 0x0023)
#define QERR_NOTHING_FOUND	(QERR_MASK | 0x0024)
#define QERR_TIME		(QERR_MASK | 0x0025)
#define QERR_SIZE		(QERR_MASK | 0x0026)
#define QERR_ADMIN		(QERR_MASK | 0x0027)
#define QERR_FILE_NOT_FOUND	(QERR_MASK | 0x0028)
#define QERR_SVC_BUSY		(QERR_MASK | 0x0029)
#define QERR_NETWORK_ERROR	(QERR_MASK | 0x002A)
#define QERR_NOT_BOUND		(QERR_MASK | 0x002B)
#define QERR_FILTER_ERROR	(QERR_MASK | 0x002C)
#define QERR_SEARCHES_FAILED (QERR_MASK | 0x002D)
#define QERR_LOST_SERVER_CONNECTION (QERR_MASK | 0x002E)

class AFX_EXT_CLASS QError  
{
public:
	QError( QErrCode errcode = QERR_OK );
  QError( int ldaperr, LDAPMessage *lm = NULL );
	virtual ~QError();

public:
  void Set( QErrCode e ) { errcode = e; } ;
  void Print(CString &str);
  QErrCode ErrorCode() { return errcode; } ;
	QError &operator=( QError &rErr );

private:
  QErrCode errcode;
};

#endif // !defined(AFX_QERROR_H__31AFB0A6_A6FD_11D2_89E9_980EE8619202__INCLUDED_)
