// QTask.h: interface for the QTask class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QTASK_H__75832E61_AF0E_11D2_89E9_B06A808FF02F__INCLUDED_)
#define AFX_QTASK_H__75832E61_AF0E_11D2_89E9_B06A808FF02F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

extern "C" {
#ifdef _NS_LDAP
#include "ldap.h"
#else
#include "winldap.h"
#endif
}

#include "QRequest.h"
#include "ptrlist.h"

class QTask  
{
public:
	QTask( QDSManager *ds, ConnID conn_id )
    {
      this->ds = ds;
      this->conn_id = conn_id;
    };

	virtual ~QTask();

public:
  void Abort();

private:
  // LDAP request type and message identifier
  int ldap_req_type;
  int ldap_msg_id;

private:
  // The directory context
  QDSManager *ds;

  // Connection identifier
  ConnID conn_id;
};

template PtrList<QTask>;

#endif // !defined(AFX_QTASK_H__75832E61_AF0E_11D2_89E9_B06A808FF02F__INCLUDED_)

